searchNodes=[{"doc":"To build a LiveState application, you'll first want to add a channel that use s this module. use LiveState.Channel , web_module : MyAppWeb , json_patch : true , max_version : 100 json_patch optional, defaults to false . If true, each time a new state is returned from a handle_XXX callback a diff will be computed and a JSON patch send to the client. max_version optional, defaults to 1000. This is the maximum version number, after which it will reset to 0 and begin incrementing again. Version numbers are used to detect a patch message arriving out of order. If such a condition is detected by phx-live-state a new copy of state is requested.","ref":"LiveState.Channel.html","title":"LiveState.Channel","type":"behaviour"},{"doc":"Called from join to authorize the connection. Return {:ok, socket} to authorize or {:error, reason} to deny. Default implementation returns {:ok, socket}","ref":"LiveState.Channel.html#c:authorize/3","title":"LiveState.Channel.authorize/3","type":"callback"},{"doc":"Receives an event an payload from the client and current state. Return a :reply tuple if you need to send events to the client, otherwise return :noreply . :reply tuples can contain a single LiveState.Event or a list of events as well as the new state.","ref":"LiveState.Channel.html#c:handle_event/3","title":"LiveState.Channel.handle_event/3","type":"callback"},{"doc":"Receive an event name, payload, the current state, and the socket. Use this callback if you need to receive the socket as well as the state. Return a :reply tuple if you need to send events to the client, otherwise return :noreply . :reply tuples can contain a single LiveState.Event or a list of events, as well as the new state and the socket. :noreply tuples must contain the new state and and socket.","ref":"LiveState.Channel.html#c:handle_event/4","title":"LiveState.Channel.handle_event/4","type":"callback"},{"doc":"Receives pubsub message and current state. Returns new state","ref":"LiveState.Channel.html#c:handle_message/2","title":"LiveState.Channel.handle_message/2","type":"callback"},{"doc":"Returns the initial application state. Called just after connection","ref":"LiveState.Channel.html#c:init/3","title":"LiveState.Channel.init/3","type":"callback"},{"doc":"The key on assigns to hold application state. Defaults to :state .","ref":"LiveState.Channel.html#c:state_key/0","title":"LiveState.Channel.state_key/0","type":"callback"},{"doc":"The key on assigns to hold application state version. Defaults to :version .","ref":"LiveState.Channel.html#c:state_version_key/0","title":"LiveState.Channel.state_version_key/0","type":"callback"},{"doc":"","ref":"LiveState.Event.html","title":"LiveState.Event","type":"module"},{"doc":"Represents a CustomEvent to be returned from a reply and dispatched on the client. Fields: name: becomes the name of the CustomEvent to be dispatched detail: becomes the detail property (payload) of the CustomEvent. Not that because events will be serialized as JSON, everything here must implement Jason.Encoder","ref":"LiveState.Event.html#t:t/0","title":"LiveState.Event.t/0","type":"type"},{"doc":"","ref":"LiveState.TestHelpers.html","title":"LiveState.TestHelpers","type":"module"},{"doc":"Asserts that state:change message is received over a channel matching the specified pattern","ref":"LiveState.TestHelpers.html#assert_state_change/1","title":"LiveState.TestHelpers.assert_state_change/1","type":"macro"},{"doc":"Asserts that state:patch message is received over a channel matching the specified pattern","ref":"LiveState.TestHelpers.html#assert_state_patch/1","title":"LiveState.TestHelpers.assert_state_patch/1","type":"macro"},{"doc":"Pushes a live state event over the channel","ref":"LiveState.TestHelpers.html#send_event/3","title":"LiveState.TestHelpers.send_event/3","type":"function"},{"doc":"Generates a Livestate channel. $ mix live_state.gen.channel Todo Accepts the module name for the channel The generated files will contain: For a regular application: a channel in lib/my_app_web/channels a channel test in test/my_app_web/channels","ref":"Mix.Tasks.LiveState.Gen.Channel.html","title":"Mix.Tasks.LiveState.Gen.Channel","type":"task"},{"doc":"Generates a Livestate channel. $ mix live_state.gen.channel Todo Accepts the module name for the channel The generated files will contain: For a regular application: a channel in lib/my_app_web/channels a channel test in test/my_app_web/channels","ref":"Mix.Tasks.LiveState.Gen.Element.html","title":"Mix.Tasks.LiveState.Gen.Element","type":"task"},{"doc":"This the elixir library for building servers for LiveState applications.","ref":"readme.html","title":"LiveState","type":"extras"},{"doc":"The goal of LiveState is to make building highly interactive web applications easier to build. Currently in most such applications clients send requests and receive responses from and to a server API. This essentially results in two applications, with state being managed in both in an ad hoc way. LiveState uses a different approach. Clients dispatch events, which are sent to the server to be handled, and receive updates from the server any time application state changes. This allows state to have a single source of truth, and greatly reduces client code complexity. It also works equally well for applications where updates to state can occur indepently from a user initiated client side event (think &quot;real time&quot; applications such as chat, etc).","ref":"readme.html#what-is-livestate","title":"LiveState - What is LiveState?","type":"extras"},{"doc":"LiveState shares similar goals to LiveView, but takes a different approach which allows for building different kinds of applications. LiveView allows the user to write all of the application code, both server logic and view presentation logic, in Elixir, and manages the web client side of the application entirely. LiveState event handlers are written in Elixir and quite similar to LiveView event handlers, but LiveState relies on client code to render state and dispatch events. This trade-off keeps client side code simple, but allows LiveState to be used to build applications that are not as good of a fit for LiveView.","ref":"readme.html#how-is-livestate-different-from-liveview","title":"LiveState - How is LiveState different from LiveView?","type":"extras"},{"doc":"This package can be installed by adding live_state to your list of dependencies in mix.exs : def deps do [ { :live_state , &quot;~&gt; 0.7.0&quot; } , { :cors_plug , &quot;~&gt; 3.0&quot; } ] end While cors_plug is not strictly required, you will very likely want it to be able to add to your endpoint so that clients cannot connect to your channel.","ref":"readme.html#installation","title":"LiveState - Installation","type":"extras"},{"doc":"First you need to setup a socket as you would with normal other Phoenix Channels On your Endpoint module, setup a socket for your channel: defmodule MyAppWeb.Endpoint do socket &quot;/socket&quot; , PgLiveHeroWeb.Channels.LiveStateSocket ... Then create the socket module with the topic to listen to: defmodule MyAppWeb.Socket do use Phoenix.Socket channel &quot;topic&quot; , MyAppWeb.Channel @impl true def connect ( _params , socket ) , do : { :ok , socket } @impl true def id ( _ ) , do : &quot;random_id&quot; end Create you channel using the LiveState.Channel behaviour: defmodule MyAppWeb.Channel do use LiveState.Channel , web_module : MyAppWeb ... Then want to define your initial state using the LiveState.Channel.init/3 callback which will be called after channel joins and is expected to return the initial state: def init ( _channel , _payload , _socket ) , do : { :ok , %{ foo : &quot;bar&quot; } } State must be a map. It will be sent down as JSON so anything in it must have a Jason.Encoder implementation.","ref":"readme.html#usage","title":"LiveState - Usage","type":"extras"},{"doc":"For events emitted from the client, you implement the LiveState.Channel.handle_event/3 callback. If you need access the socket in your event handler, you may implement LiveState.Channel.handle_event/4 . def handle_event ( &quot;add_todo&quot; , todo , %{ todos : todos } ) do { :noreply , %{ todos : [ todo | todos ] } } end LiveState.Channel.handle_event/3 receives the following arguments event name payload current And returns a tuple whose last element is the new state. It can also return one or many events to dispatch on the calling DOM Element: def handle_event ( &quot;add_todo_with_one_reply&quot; , todo , %{ todos : todos } ) do { :reply , % Event { name : &quot;reply_event&quot; , detail : %{ foo : &quot;bar&quot; } } , %{ todos : [ todo | todos ] } } end def handle_event ( &quot;add_todo_with_two_replies&quot; , todo , %{ todos : todos } ) do { :reply , [ % Event { name : &quot;reply_event1&quot; , detail : %{ foo : &quot;bar&quot; } } , % Event { name : &quot;reply_event2&quot; , detail : %{ bing : &quot;baz&quot; } } ] , %{ todos : [ todo | todos ] } } end","ref":"readme.html#events","title":"LiveState - Events","type":"extras"},{"doc":"Tutorial - A step by step guide to building an embedded app using LiveState API Docs are available in the hex package .","ref":"readme.html#documentation","title":"LiveState - Documentation","type":"extras"},{"doc":"","ref":"readme.html#related-projects","title":"LiveState - Related projects","type":"extras"},{"doc":"The front end library npm package that implements sending and receiving events, and subscribing to state changes. It also facilitates building Custom Elements that are backed by LiveState.","ref":"readme.html#phx-live-state","title":"LiveState - phx-live-state","type":"extras"},{"doc":"A react hook for LiveState.","ref":"readme.html#use-live-state","title":"LiveState - use-live-state","type":"extras"},{"doc":"This is a phoenix project that mainly provides integration tests for LiveState. It's also a great place to see examples of how to use LiveState","ref":"readme.html#live_state_testbed","title":"LiveState - live_state_testbed","type":"extras"},{"doc":"There are several examples of full LiveState projects. This blog post covers building a embeddable comments section custom element. The relevant source code repos: https://github.com/launchscout/live_state_comments https://github.com/launchscout/livestate-comments This talk from ElixirConf 2022 also covers LiveState in detail. The code examples from the talk are in the repos below: https://github.com/launchscout/discord_element https://github.com/launchscout/discord-element","ref":"readme.html#other-resources","title":"LiveState - Other resources","type":"extras"}]